install.sh 7.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. SUDO=
  29. if [ "$(id -u)" -ne 0 ]; then
  30. # Running as root, no need for sudo
  31. if ! available sudo; then
  32. error "This script requires superuser permissions. Please re-run as root."
  33. fi
  34. SUDO="sudo"
  35. fi
  36. NEEDS=$(require curl awk grep sed tee xargs)
  37. if [ -n "$NEEDS" ]; then
  38. status "ERROR: The following tools are required but missing:"
  39. for NEED in $NEEDS; do
  40. echo " - $NEED"
  41. done
  42. exit 1
  43. fi
  44. status "Downloading ollama..."
  45. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  46. for BINDIR in /usr/local/bin /usr/bin /bin; do
  47. echo $PATH | grep -q $BINDIR && break || continue
  48. done
  49. status "Installing ollama to $BINDIR..."
  50. $SUDO install -o0 -g0 -m755 -d $BINDIR
  51. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  52. install_success() { status 'Install complete. Run "ollama" from the command line.'; }
  53. trap install_success EXIT
  54. # Everything from this point onwards is optional.
  55. configure_systemd() {
  56. if ! id ollama >/dev/null 2>&1; then
  57. status "Creating ollama user..."
  58. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  59. fi
  60. status "Adding current user to ollama group..."
  61. $SUDO usermod -a -G ollama $(whoami)
  62. status "Creating ollama systemd service..."
  63. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  64. [Unit]
  65. Description=Ollama Service
  66. After=network-online.target
  67. [Service]
  68. ExecStart=$BINDIR/ollama serve
  69. User=ollama
  70. Group=ollama
  71. Restart=always
  72. RestartSec=3
  73. Environment="HOME=/usr/share/ollama"
  74. Environment="PATH=$PATH"
  75. [Install]
  76. WantedBy=default.target
  77. EOF
  78. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  79. case $SYSTEMCTL_RUNNING in
  80. running|degraded)
  81. status "Enabling and starting ollama service..."
  82. $SUDO systemctl daemon-reload
  83. $SUDO systemctl enable ollama
  84. start_service() { $SUDO systemctl restart ollama; }
  85. trap start_service EXIT
  86. ;;
  87. esac
  88. }
  89. if available systemctl; then
  90. configure_systemd
  91. fi
  92. if ! available lspci && ! available lshw; then
  93. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  94. exit 0
  95. fi
  96. check_gpu() {
  97. case $1 in
  98. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  99. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  100. nvidia-smi) available nvidia-smi || return 1 ;;
  101. esac
  102. }
  103. if check_gpu nvidia-smi; then
  104. status "NVIDIA GPU installed."
  105. exit 0
  106. fi
  107. if ! check_gpu lspci && ! check_gpu lshw; then
  108. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  109. exit 0
  110. fi
  111. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  112. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  113. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  114. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  115. install_cuda_driver_yum() {
  116. status 'Installing NVIDIA repository...'
  117. case $PACKAGE_MANAGER in
  118. yum)
  119. $SUDO $PACKAGE_MANAGER -y install yum-utils
  120. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  121. ;;
  122. dnf)
  123. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  124. ;;
  125. esac
  126. case $1 in
  127. rhel)
  128. status 'Installing EPEL repository...'
  129. # EPEL is required for third-party dependencies such as dkms and libvdpau
  130. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  131. ;;
  132. esac
  133. status 'Installing CUDA driver...'
  134. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  135. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  136. fi
  137. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  138. }
  139. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  140. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  141. install_cuda_driver_apt() {
  142. status 'Installing NVIDIA repository...'
  143. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  144. case $1 in
  145. debian)
  146. status 'Enabling contrib sources...'
  147. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | sudo tee /etc/apt/sources.list.d/contrib.list > /dev/null
  148. ;;
  149. esac
  150. status 'Installing CUDA driver...'
  151. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  152. $SUDO apt-get update
  153. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  154. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  155. }
  156. if [ ! -f "/etc/os-release" ]; then
  157. error "Unknown distribution. Skipping CUDA installation."
  158. fi
  159. . /etc/os-release
  160. OS_NAME=$ID
  161. OS_VERSION=$VERSION_ID
  162. PACKAGE_MANAGER=
  163. for PACKAGE_MANAGER in dnf yum apt-get; do
  164. if available $PACKAGE_MANAGER; then
  165. break
  166. fi
  167. done
  168. if [ -z "$PACKAGE_MANAGER" ]; then
  169. error "Unknown package manager. Skipping CUDA installation."
  170. fi
  171. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  172. case $OS_NAME in
  173. centos|rhel) install_cuda_driver_yum 'rhel' $OS_VERSION ;;
  174. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  175. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  176. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  177. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  178. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  179. *) exit ;;
  180. esac
  181. fi
  182. if ! lsmod | grep -q nvidia; then
  183. KERNEL_RELEASE="$(uname -r)"
  184. case $OS_NAME in
  185. centos|rhel|rocky|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  186. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  187. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  188. *) exit ;;
  189. esac
  190. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  191. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  192. $SUDO dkms install $NVIDIA_CUDA_VERSION
  193. fi
  194. if lsmod | grep -q nouveau; then
  195. status 'Reboot to complete NVIDIA CUDA driver install.'
  196. exit 0
  197. fi
  198. $SUDO modprobe nvidia
  199. fi
  200. status "NVIDIA CUDA drivers installed."